Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkClipDataSet Class Reference

`#include <vtkClipDataSet.h>`

Inheritance diagram for vtkClipDataSet:

[legend]
Collaboration diagram for vtkClipDataSet:

[legend]
List of all members.

## Detailed Description

clip any dataset with user-specified implicit function or input scalar data

Date:
  2003/01/17 14:28:02

Revision:
  1.15

vtkClipDataSet is a filter that any type of dataset using either any subclass of vtkImplicitFunction, or the input scalar data. Clipping means that it actually "cuts" through the cells of the dataset, returning everything inside of the specified implicit function (or greater than the scalar value) including "pieces" of a cell. (Compare this with vtkExtractGeometry, which pulls out entire, uncut cells.) The output of this filter is an unstructured grid.

To use this filter, you must decide if you will be clipping with an implicit function, or whether you will be using the input scalar data. If you want to clip with an implicit function, you must: 1) define an implicit function 2) set it with the SetClipFunction method 3) apply the GenerateClipScalarsOn method If a ClipFunction is not specified, or GenerateClipScalars is off (the default), then the input's scalar data will be used to clip the polydata.

You can also specify a scalar value, which is used to decide what is inside and outside of the implicit function. You can also reverse the sense of what inside/outside is by setting the InsideOut instance variable. (The clipping algorithm proceeds by computing an implicit function value or using the input scalar data for each point in the dataset. This is compared to the scalar value to determine inside/outside.)

This filter can be configured to compute a second output. The second output is the part of the cell that is clipped away. Set the GenerateClippedData boolean on if you wish to access this output data.

Warning:
  vtkClipDataSet will triangulate all types of 3D cells (i.e., create tetrahedra). This is true even if the cell is not actually cut. This is necessary to preserve compatibility across face neighbors. 2D cells will only be triangulated if the cutting function passes through them.

See also:
  vtkImplicitFunction vtkCutter vtkClipVolume vtkClipPolyData

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (74%)
  - Law, Charles (9%)
  - Cedilnik, Andy (5%)

CVS logs (CVSweb):
  - .`cxx` (`/Graphics/vtkClipDataSet.cxx)`
  - .`h` (`/Graphics/vtkClipDataSet.h)`

Tests:
  vtkClipDataSet (Tests)

Definition at line 87 of file vtkClipDataSet.h.

## Public Types
typedef vtkDataSetToUnstructuredGridFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | CreateDefaultLocator ()
unsigned long | GetMTime ()
virtual void | SetValue (float)
virtual float | GetValue ()
virtual void | SetInsideOut (int)
virtual int | GetInsideOut ()
virtual void | InsideOutOn ()
virtual void | InsideOutOff ()
virtual void | SetClipFunction (vtkImplicitFunction *)
virtual vtkImplicitFunction * | GetClipFunction ()
virtual void | SetGenerateClipScalars (int)
virtual int | GetGenerateClipScalars ()
virtual void | GenerateClipScalarsOn ()
virtual void | GenerateClipScalarsOff ()
virtual void | SetGenerateClippedOutput (int)
virtual int | GetGenerateClippedOutput ()
virtual void | GenerateClippedOutputOn ()
virtual void | GenerateClippedOutputOff ()
virtual void | SetMergeTolerance (float)
virtual float | GetMergeTolerance ()
vtkUnstructuredGrid * | GetClippedOutput ()
virtual int | GetNumberOfOutputs ()
void | SetLocator (vtkPointLocator *locator)
virtual vtkPointLocator * | GetLocator ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkClipDataSet * | SafeDownCast (vtkObject *o)
vtkClipDataSet * | New ()
## Protected Methods
| vtkClipDataSet (vtkImplicitFunction *cf=NULL)
| ~vtkClipDataSet ()
void | Execute ()
virtual void | SetInputScalarsSelection (const char *)
void | ClipVolume ()
## Protected Attributes
vtkImplicitFunction * | ClipFunction
vtkPointLocator * | Locator
int | InsideOut
float | Value
int | GenerateClipScalars
int | GenerateClippedOutput
float | MergeTolerance
char * | InputScalarsSelection

## Member Typedef Documentation

typedef vtkDataSetToUnstructuredGridFilter vtkClipDataSet::Superclass

| Reimplemented from vtkDataSetToUnstructuredGridFilter. Definition at line 90 of file vtkClipDataSet.h.

## Constructor & Destructor Documentation

vtkClipDataSet::vtkClipDataSet | ( | vtkImplicitFunction * | cf = NULL | ) | `[protected]`

vtkClipDataSet::~vtkClipDataSet | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkClipDataSet::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkDataSetToUnstructuredGridFilter.

int vtkClipDataSet::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSetToUnstructuredGridFilter.

virtual int vtkClipDataSet::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataSetToUnstructuredGridFilter.

vtkClipDataSet* vtkClipDataSet::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkDataSetToUnstructuredGridFilter.

void vtkClipDataSet::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkDataSetToUnstructuredGridFilter.

vtkClipDataSet* vtkClipDataSet::New | ( |  | ) | `[static]`

| Construct with user-specified implicit function; InsideOut turned off; value set to 0.0; and generate clip scalars turned off. Reimplemented from vtkObject.

virtual void vtkClipDataSet::SetValue | ( | float |  | ) | `[virtual]`

| Set the clipping value of the implicit function (if clipping with implicit function) or scalar value (if clipping with scalars). The default value is 0.0.

virtual float vtkClipDataSet::GetValue | ( |  | ) | `[virtual]`

| Set the clipping value of the implicit function (if clipping with implicit function) or scalar value (if clipping with scalars). The default value is 0.0.

virtual void vtkClipDataSet::SetInsideOut | ( | int |  | ) | `[virtual]`

| Set/Get the InsideOut flag. When off, a vertex is considered inside the implicit function if its value is greater than the Value ivar. When InsideOutside is turned on, a vertex is considered inside the implicit function if its implicit function value is less than or equal to the Value ivar. InsideOut is off by default.

virtual int vtkClipDataSet::GetInsideOut | ( |  | ) | `[virtual]`

| Set/Get the InsideOut flag. When off, a vertex is considered inside the implicit function if its value is greater than the Value ivar. When InsideOutside is turned on, a vertex is considered inside the implicit function if its implicit function value is less than or equal to the Value ivar. InsideOut is off by default.

virtual void vtkClipDataSet::InsideOutOn | ( |  | ) | `[virtual]`

| Set/Get the InsideOut flag. When off, a vertex is considered inside the implicit function if its value is greater than the Value ivar. When InsideOutside is turned on, a vertex is considered inside the implicit function if its implicit function value is less than or equal to the Value ivar. InsideOut is off by default.

virtual void vtkClipDataSet::InsideOutOff | ( |  | ) | `[virtual]`

| Set/Get the InsideOut flag. When off, a vertex is considered inside the implicit function if its value is greater than the Value ivar. When InsideOutside is turned on, a vertex is considered inside the implicit function if its implicit function value is less than or equal to the Value ivar. InsideOut is off by default.

virtual void vtkClipDataSet::SetClipFunction | ( | vtkImplicitFunction * |  | ) | `[virtual]`

| Specify the implicit function with which to perform the clipping. If you do not define an implicit function, then the selected input scalar data will be used for clipping.

virtual vtkImplicitFunction* vtkClipDataSet::GetClipFunction | ( |  | ) | `[virtual]`

| Specify the implicit function with which to perform the clipping. If you do not define an implicit function, then the selected input scalar data will be used for clipping.

virtual void vtkClipDataSet::SetGenerateClipScalars | ( | int |  | ) | `[virtual]`

| If this flag is enabled, then the output scalar values will be interpolated from the implicit function values, and not the input scalar data. If you enable this flag but do not provide an implicit function an error will be reported.

virtual int vtkClipDataSet::GetGenerateClipScalars | ( |  | ) | `[virtual]`

| If this flag is enabled, then the output scalar values will be interpolated from the implicit function values, and not the input scalar data. If you enable this flag but do not provide an implicit function an error will be reported.

virtual void vtkClipDataSet::GenerateClipScalarsOn | ( |  | ) | `[virtual]`

| If this flag is enabled, then the output scalar values will be interpolated from the implicit function values, and not the input scalar data. If you enable this flag but do not provide an implicit function an error will be reported.

virtual void vtkClipDataSet::GenerateClipScalarsOff | ( |  | ) | `[virtual]`

| If this flag is enabled, then the output scalar values will be interpolated from the implicit function values, and not the input scalar data. If you enable this flag but do not provide an implicit function an error will be reported.

virtual void vtkClipDataSet::SetGenerateClippedOutput | ( | int |  | ) | `[virtual]`

| Control whether a second output is generated. The second output contains the polygonal data that's been clipped away.

virtual int vtkClipDataSet::GetGenerateClippedOutput | ( |  | ) | `[virtual]`

| Control whether a second output is generated. The second output contains the polygonal data that's been clipped away.

virtual void vtkClipDataSet::GenerateClippedOutputOn | ( |  | ) | `[virtual]`

| Control whether a second output is generated. The second output contains the polygonal data that's been clipped away.

virtual void vtkClipDataSet::GenerateClippedOutputOff | ( |  | ) | `[virtual]`

| Control whether a second output is generated. The second output contains the polygonal data that's been clipped away.

virtual void vtkClipDataSet::SetMergeTolerance | ( | float |  | ) | `[virtual]`

| Set the tolerance for merging clip intersection points that are near the vertices of cells. This tolerance is used to prevent the generation of degenerate primitives. Note that only 3D cells actually use this instance variable.

virtual float vtkClipDataSet::GetMergeTolerance | ( |  | ) | `[virtual]`

| Set the tolerance for merging clip intersection points that are near the vertices of cells. This tolerance is used to prevent the generation of degenerate primitives. Note that only 3D cells actually use this instance variable.

vtkUnstructuredGrid* vtkClipDataSet::GetClippedOutput | ( |  | ) |

| Return the Clipped output.

virtual int vtkClipDataSet::GetNumberOfOutputs | ( |  | ) | `[virtual]`

| Return the Clipped output. Reimplemented from vtkSource.

void vtkClipDataSet::SetLocator | ( | vtkPointLocator * | locator | ) |

| Specify a spatial locator for merging points. By default, an instance of vtkMergePoints is used.

virtual vtkPointLocator* vtkClipDataSet::GetLocator | ( |  | ) | `[virtual]`

| Specify a spatial locator for merging points. By default, an instance of vtkMergePoints is used.

void vtkClipDataSet::CreateDefaultLocator | ( |  | ) |

| Create default locator. Used to create one when none is specified. The locator is used to merge coincident points.

unsigned long vtkClipDataSet::GetMTime | ( |  | ) | `[virtual]`

| Return the mtime also considering the locator and clip function. Reimplemented from vtkObject.

void vtkClipDataSet::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

virtual void vtkClipDataSet::SetInputScalarsSelection | ( | const char * |  | ) | `[protected, virtual]`

void vtkClipDataSet::ClipVolume | ( |  | ) | `[protected]`

## Member Data Documentation

vtkImplicitFunction* vtkClipDataSet::ClipFunction`[protected]`

| Definition at line 176 of file vtkClipDataSet.h.

vtkPointLocator* vtkClipDataSet::Locator`[protected]`

| Definition at line 178 of file vtkClipDataSet.h.

int vtkClipDataSet::InsideOut`[protected]`

| Definition at line 179 of file vtkClipDataSet.h.

float vtkClipDataSet::Value`[protected]`

| Definition at line 180 of file vtkClipDataSet.h.

int vtkClipDataSet::GenerateClipScalars`[protected]`

| Definition at line 181 of file vtkClipDataSet.h.

int vtkClipDataSet::GenerateClippedOutput`[protected]`

| Definition at line 183 of file vtkClipDataSet.h.

float vtkClipDataSet::MergeTolerance`[protected]`

| Definition at line 184 of file vtkClipDataSet.h.

char* vtkClipDataSet::InputScalarsSelection`[protected]`

| Definition at line 186 of file vtkClipDataSet.h.

The documentation for this class was generated from the following file:

- Graphics/vtkClipDataSet.h